/* $Header: /BARCODE LIB/1D_LIB/QTOOLS-1.0/src/cr_ufl/ufjob.cpp 1     9/19/00 8:01a Coryking $
**
** File:    UFJob.c
** Author:  Rick Cameron
** Date:    13 Mar 93
**
** Purpose: Implementation of functions to support job management.
*/


/* Modified: Cory King - Janurary 29, 1998 
**
** $History: ufjob.cpp $
 * 
 * *****************  Version 1  *****************
 * User: Coryking     Date: 9/19/00    Time: 8:01a
 * Created in $/BARCODE LIB/1D_LIB/QTOOLS-1.0/src/cr_ufl
 * AzaleaQTools V1.0
 * 
 * *****************  Version 1  *****************
 * User: Coryking     Date: 4/04/00    Time: 2:23p
 * Created in $/BARCODE LIB/CR_UFL/cr_pool
 * 
 * *****************  Version 1  *****************
 * User: Coryking     Date: 2/29/00    Time: 2:48p
 * Created in $/BARCODE LIB/CR_UFL/cr_pool
 * 
 * *****************  Version 1  *****************
 * User: Coryking     Date: 10/19/99   Time: 3:30p
 * Created in $/CR_UFL/cr_pool
 * Crystal Report lib based on general C/C++ .lib file
**
*/
#include <Windows.h>
#include "UFDll.h"
#include "UFMain.h"
#include "UFUser.h"
#include "UFJob.h"

#include <StdLib.h>

static struct JobInfo FAR *Root = 0;

void InitForJob (UFTInt32u jobId)
{
    struct JobInfo FAR *jobInfo;

    jobInfo = FindJobInfo (jobId);

    if (jobInfo == 0)
    {
        /* was: ... = malloc(...) */
		jobInfo = (struct JobInfo FAR *)malloc (sizeof (struct JobInfo));

        if (jobInfo != 0)
        {
            jobInfo->jobId = jobId;
            jobInfo->data  = 0;

            jobInfo->prev = 0;
            jobInfo->next = Root;

            if (Root != 0)
                Root->prev = jobInfo;

            Root = jobInfo;

            InitJob (jobInfo);
        }
    }
}

void TermForJob (UFTInt32u jobId)
{
    struct JobInfo FAR *jobInfo;

    jobInfo = FindJobInfo (jobId);

    if (jobInfo != 0)
    {
        TermJob (jobInfo);

        if (jobInfo->prev != 0)
            jobInfo->prev->next = jobInfo->next;
        else
            Root = jobInfo->next;

        if (jobInfo->next != 0)
            jobInfo->next->prev = jobInfo->prev;

        free (jobInfo);
    }
}

struct JobInfo FAR *FindJobInfo (UFTInt32u jobId)
{
    struct JobInfo FAR *cursor = Root;

    while (cursor != 0)
    {
        if (cursor->jobId == jobId)
            break;

        cursor = cursor->next;
    }

    return cursor;
}

