/****************************************************************************
  File:    PLATFORM.H
  Module:  1D Barcodes Library

  Prototype: n/a

  Revision History:
    03May00  J R Slack  File created; for Beta3 DLL build.

  Description:  Platform-dependent and compiler-dependent defines.

  Copyright (C) Azalea Software, Inc. 1995...2000.  All rights reserved.

****************************************************************************/

#if !defined(_PLATFORM_H)
#define _PLATFORM_H

// some useful types
typedef unsigned  char  BYTE;
typedef unsigned short  WORD;   // for VB'ers, use Integer

#define BCODE_WORD WORD

#if defined WIN32  // MSVC automatically declares WIN32...

   #define LIB_PROC  __stdcall
   #define EXTERN_C  extern "C"

#elif defined WIN__16

   #define LIB_PROC  _far _pascal
   #define EXTERN__C  extern "C"

#else  // default (Linux, Mac, debug, etc.)
   #define LIB_PROC
   #define EXTERN__C

#endif

#endif // _PLATFORM_H

/* end PLATFORM.H */
